﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="InfragisticsHG_events._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <h2>
        Welcome to ASP.NET!
    </h2>
    <div id="gridHolder">
    <table id="gridTarget"></table>
    </div>
    <div id="infoTarget"></div>
    <input type="button" value="Clear" id="clear" />
    <script type="text/javascript">
        $(document).ready(function () {
            var grid = $("#gridTarget");

            grid.igHierarchicalGrid({
                dataSource: hierarchicalProjects, // this comes off data.js
                dataSourceType: "json",
                width: 500,
                responseDataKey: "Records",
                localSchemaTransform: true,
                autoGenerateColumns: false,
                autoGenerateLayouts: false,
                primaryKey: "ProjectId",
                columns: [
                { headerText: "Project ID", key: "ProjectId", dataType: "number" },
                { headerText: "Name", key: "Name" },
                { headerText: "Start Date", key: "StartDate", dataType: "date" },
                { headerText: "End Date", key: "EndDate", dataType: "date" }
            ],
                columnLayouts: [{ // first level grid
                    caption: "Developers",
                    key: "Developers",
                    responseDataKey: "Records",
                    autoGenerateColumns: false,
                    autoGenerateLayouts: false,
                    primaryKey: "DeveloperId",
                    foreignKey: "ProjectId",
                    columns: [
                    { headerText: "Developer ID", key: "DeveloperId", dataType: "number" },
                    { headerText: "Project ID", key: "ProjectId", dataType: "number" },
                    { headerText: "Name", key: "Name" }
                ],
                    features: [ // these features override the global ones
                {
                name: "Paging",
                type: "local",
                pageSize: 6,
                inherit: true
            }],
                    columnLayouts: [{ // second level grid
                        caption: "Virtual Machines",
                        key: "VirtualMachines",
                        autoGenerateColumns: false,
                        autoGenerateLayouts: false,
                        responseDataKey: "Records",
                        columns: [
                        { headerText: "Virtual Machine", key: "VirtualMachineId" },
                        { headerText: "Operating System", key: "OperatingSystem" },
                        { headerText: "Expiration Date", key: "ExpirationDate", dataType: "date" }
                    ]
                    }]
                },
            { // first level grid
                caption: "Tasks",
                key: "Tasks",
                responseDataKey: "Records",
                autoGenerateColumns: false,
                autoGenerateLayouts: false,
                primaryKey: "TaskId",
                foreignKey: "ProjectId",
                columns: [
                    { headerText: "Task ID", key: "TaskId", dataType: "number" },
                    { headerText: "Project ID", key: "ProjectId", dataType: "number" },
                    { headerText: "Task Name", key: "Name" }
                ],
                columnLayouts: [{ // second level grid
                    caption: "Check-ins",
                    key: "Checkins",
                    responseDataKey: "Records",
                    autoGenerateColumns: false,
                    autoGenerateLayouts: false,
                    primaryKey: "CheckinId",
                    foreignKey: "TaskId",
                    columns: [
                        { headerText: "Check-in ID", key: "CheckinId", dataType: "number" },
                        { headerText: "Task ID", key: "TaskId", dataType: "number" },
                        { headerText: "Check-in Date", key: "CheckinDate", dataType: "date" }
                    ],
                    features: [ // these features override the global ones
                    {
                    name: "Paging",
                    type: "local",
                    pageSize: 6,
                    inherit: true
                }],
                columnLayouts: [{ // third level grid
                    key: "Files",
                    responseDataKey: "Records",
                    autoGenerateColumns: false,
                    autoGenerateLayouts: false,
                    primaryKey: "FileId",
                    foreignKey: "CheckinId",
                    columns: [
                            { headerText: "File ID", key: "FileId", dataType: "number" },
                            { headerText: "Check-in ID", key: "CheckinId", dataType: "number" },
                            { headerText: "File Name", key: "Name" }
                        ]
                }]
            }]
        },
            { // first level grid
                caption: "Scrums",
                key: "Scrums",
                responseDataKey: "Records",
                autoGenerateColumns: false,
                autoGenerateLayouts: false,
                primaryKey: "MeetingId",
                foreignKey: "ProjectId",
                columns: [
                    { headerText: "Project ID", key: "ProjectId", dataType: "number" },
                    { headerText: "Meeting ID", key: "MeetingId", dataType: "number" },
                    { headerText: "Occured On", key: "OccurredOn", dataType: "date" }
                ]
            }],
                features: [ // global features
            {
            name: "Filtering",
            type: "local",
            mode: "simple",
            inherit: true
        },
				    {
				        name: "Paging",
				        type: "local",
				        pageSize: 3,
				        inherit: true
				    },
            {
                name: "Sorting",
                type: "local",
                inherit: true
            }],
                rowExpanding: log,
                rowExpanded: log
            });

            function log(evt, ui) {
                var row = ui.parentrow[0]; // this gets the element of the row that triggered the event
                var event_type = evt.type; // the type of event that was triggered
                var grid = $(row).closest("table"); // this is how you get EXACTLY the grid that fired the event
                var grid_id = grid.attr("id");
                var level = grid.attr("data-level"); // and its level in the hierarchy , 0 being root
                var row_index = $(row).parent().children("tr:not(tr[data-container])").index(row); // index of the row 
                var log_msg = event_type + " fired on " + grid_id + " at level " + level + ", row index " + row_index;
                if (grid_id.indexOf("Developers") >= 0)
                    $("<span>" + log_msg + "</span><br /><br />").appendTo("#infoTarget").css("color", "blue");
                else if (grid_id.indexOf("Tasks") >= 0)
                    $("<span>" + log_msg + "</span><br /><br />").appendTo("#infoTarget").css("color", "green");
                else if (grid_id.indexOf("Checkins") >= 0)
                    $("<span>" + log_msg + "</span><br /><br />").appendTo("#infoTarget").css("color", "red");
                else if (grid_id.indexOf("gridTarget") >= 0)
                    $("<span>" + log_msg + "</span></br></br>").appendTo("#infoTarget").css("color", "orange");

                grid.animate({ opacity: 0.25 }).animate({ opacity: 1.0 }); // this line produces a "flash" on every event trigger
            }

            $("#gridTarget").live("iggridsortingcolumnsorted", function (evt, ui) {
                var sorted_id = ui.owner.grid.id(); // here we get the widget's ID - much easier
                if (sorted_id.indexOf("Developers") >= 0)
                    $("<span>Sorted fired from " + sorted_id + "</span><br /><br />").appendTo("#infoTarget").css("color", "blue");
                else if (sorted_id.indexOf("Tasks") >= 0)
                    $("<span>Sorted fired from " + sorted_id + "</span><br /><br />").appendTo("#infoTarget").css("color", "green");
                else if (sorted_id.indexOf("Checkins") >= 0)
                    $("<span>Sorted fired from " + sorted_id + "</span><br /><br />").appendTo("#infoTarget").css("color", "red");
                else if (sorted_id.indexOf("gridTarget") >= 0)
                    $("<span>Sorted fired from " + sorted_id + "</span><br /><br />").appendTo("#infoTarget").css("color", "orange");
            });

            $("#clear").click(function () {
                $("#infoTarget").empty();
            });
        });
    </script>
</asp:Content>
